/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *  
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *
 */

/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tStarterTaskBody_template.c => src/tStarterTaskBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * startKey         char           ATTR_startKey   
 * lightCalibrateKey char           ATTR_lightCalibrateKey
 * sonicKey         char           ATTR_sonicKey   
 *
 * ƤӸؿ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : cSerialPort  signature: sSerialPort context: task
 *   ER             cSerialPort_open( );
 *   ER             cSerialPort_close( );
 *   ER_UINT        cSerialPort_read( char* buffer, uint_t length );
 *   ER_UINT        cSerialPort_write( const char* buffer, uint_t length );
 *   ER             cSerialPort_control( uint_t ioControl );
 *   ER             cSerialPort_refer( T_SERIAL_RPOR* pk_rpor );
 * call port : cTailControllerTask  signature: sCyclic context: task
 *   ER             cTailControllerTask_start( );
 *   ER             cTailControllerTask_stop( );
 *   ER             cTailControllerTask_refer( T_RCYC* pk_cyclicHandlerStatus );
 * call port : cBalancerTask  signature: sCyclic context: task
 *   ER             cBalancerTask_start( );
 *   ER             cBalancerTask_stop( );
 *   ER             cBalancerTask_refer( T_RCYC* pk_cyclicHandlerStatus );
 * call port : cLinetracerTask  signature: sCyclic context: task
 *   ER             cLinetracerTask_start( );
 *   ER             cLinetracerTask_stop( );
 *   ER             cLinetracerTask_refer( T_RCYC* pk_cyclicHandlerStatus );
 * call port : cTailControllerCalibrate  signature: sCalibrate context: task
 *   void           cTailControllerCalibrate_body( );
 * call port : cBalancerCalibrate  signature: sCalibrate context: task
 *   void           cBalancerCalibrate_body( );
 * call port : cLinetracerCalibrate  signature: sCalibrate context: task
 *   void           cLinetracerCalibrate_body( );
 * call port : cTailController  signature: sTailController context: task
 *   void           cTailController_signalStop( );
 *   void           cTailController_signalStart( );
 * call port : cSonicSensor  signature: sSensor context: task
 *   void           cSonicSensor_getValue( uint16_t* value );
 *
 * #[</PREAMBLE>]# */

/* ץȥѿ򤳤˽񤭤ޤ */
#include "tStarterTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tStarterTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	char key;

	cTailControllerCalibrate_body();
	cTailController_signalStop();
	cTailControllerTask_start();
	
	cSerialPort_open();
	while(1){
		cSerialPort_read(&key, 1);

		if(key == ATTR_startKey){
			cBalancerCalibrate_body();
			cBalancerTask_start();
			cTailController_signalStart();
			cLinetracerTask_start();
			
			exitTask();
		} else if(key == ATTR_sonicKey){
#include <t_syslog.h>
			uint16_t sonic;
			cSonicSensor_getValue(&sonic);
			syslog(LOG_NOTICE, "sonic = %d cm", sonic);
			
		} else if(key == ATTR_lightCalibrateKey){
			cLinetracerCalibrate_body();
		}
	}
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
