/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010-2012 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *  
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *
 */

/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tBalancerTaskBody_template.c => src/tBalancerTaskBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * maxSpeed         int16_t          ATTR_maxSpeed   
 * minSpeed         int16_t          ATTR_minSpeed   
 * gyroOffset       uint16_t         VAR_gyroOffset  
 * speed            int16_t          VAR_speed       
 * turn             int16_t          VAR_turn        
 * count            int32_t          VAR_count       
 *
 * ƤӸؿ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : cRightMotor  signature: sMotor context: task
 *   void           cRightMotor_setPWM( int8_t pwm, bool_t brakeMode );
 *   void           cRightMotor_setRevolution( int32_t revolution );
 *   void           cRightMotor_getRevolution( int32_t* revolution );
 * call port : cLeftMotor  signature: sMotor context: task
 *   void           cLeftMotor_setPWM( int8_t pwm, bool_t brakeMode );
 *   void           cLeftMotor_setRevolution( int32_t revolution );
 *   void           cLeftMotor_getRevolution( int32_t* revolution );
 * call port : cGyroSensor  signature: sSensor context: task
 *   void           cGyroSensor_getValue( uint16_t* value );
 * call port : cBattery  signature: sBattery context: task
 *   uint16_t       cBattery_getBatteryVoltage( );
 * call port : cBalancer  signature: sBalancer context: task
 *   void           cBalancer_control( int16_t forward, int16_t turn, uint16_t gyro, uint16_t gyroOffset, int32_t leftRevolution, int32_t rightRevolution, uint16_t battery, int8_t* pwm_l, int8_t* pwm_r );
 *
 * #[</PREAMBLE>]# */

/* ץȥѿ򤳤˽񤭤ޤ */
#include "tBalancerTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tBalancerTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	uint16_t gyro;
	int32_t rev_r, rev_l;
	int8_t pwm_r, pwm_l;
	uint16_t battery;
    int16_t speed, turn;
	
	cRightMotor_getRevolution(&rev_r);
	cLeftMotor_getRevolution(&rev_l);
	cGyroSensor_getValue(&gyro);
	battery = cBattery_getBatteryVoltage();

    speed = VAR_speed;

    if(speed == 0){
        turn = 0;
    } else {
        turn = VAR_turn;
    }

	/*
	 *  ΩΤPWMͤη׻
	 */
	cBalancer_control(speed,
					  turn,
					  gyro,
					  VAR_gyroOffset,
					  rev_l,
					  rev_r,
					  battery,
					  &pwm_l,
					  &pwm_r);
	
	/*
	 *  PWMͤ⡼˥å
	 */
	cLeftMotor_setPWM(pwm_l, 1);
	cRightMotor_setPWM(pwm_r, 1);

    if(VAR_count++ == 250){
        syslog(LOG_NOTICE, "balancer running. speed(%d),turn(%d),gyro(%d),gyro_offset(%d)",speed,turn,gyro,VAR_gyroOffset);
        VAR_count = 0;
    }
}

/* #[<ENTRY_PORT>]# eBalancerControl
 * entry port: eBalancerControl
 * signature:  sBalancerControl
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBalancerControl_setSpeed
 * name:         eBalancerControl_setSpeed
 * global_name:  tBalancerTaskBody_eBalancerControl_setSpeed
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancerControl_setSpeed(int16_t speed)
{
	VAR_speed = speed;
}

/* #[<ENTRY_FUNC>]# eBalancerControl_getSpeed
 * name:         eBalancerControl_getSpeed
 * global_name:  tBalancerTaskBody_eBalancerControl_getSpeed
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancerControl_getSpeed(int16_t* speed)
{
	*speed = VAR_speed;
}

/* #[<ENTRY_FUNC>]# eBalancerControl_setTurn
 * name:         eBalancerControl_setTurn
 * global_name:  tBalancerTaskBody_eBalancerControl_setTurn
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancerControl_setTurn(int16_t turn)
{
	VAR_turn = turn;
}

/* #[<ENTRY_FUNC>]# eBalancerControl_getTurn
 * name:         eBalancerControl_getTurn
 * global_name:  tBalancerTaskBody_eBalancerControl_getTurn
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancerControl_getTurn(int16_t* turn)
{
	*turn = VAR_turn;
}

/* #[<ENTRY_FUNC>]# eBalancerControl_calibrate
 * name:         eBalancerControl_calibrate
 * global_name:  tBalancerTaskBody_eBalancerControl_calibrate
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancerControl_calibrate()
{
    uint16_t gyro;

    cGyroSensor_getValue(&gyro);
    VAR_gyroOffset = gyro;
    cRightMotor_setRevolution(0);
    cLeftMotor_setRevolution(0);
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
