/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2012 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *  
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *
 */
/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tGetCommandTaskBody_template.c => src/tGetCommandTaskBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * parameter        int32_t          VAR_parameter   
 * sign             int8_t           VAR_sign        
 *
 * ƤӸؿ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : cSerialPort  signature: sSerialPort context: task
 *   ER             cSerialPort_open( );
 *   ER             cSerialPort_close( );
 *   ER_UINT        cSerialPort_read( char* buffer, uint_t length );
 *   ER_UINT        cSerialPort_write( const char* buffer, uint_t length );
 *   ER             cSerialPort_control( uint_t ioControl );
 *   ER             cSerialPort_refer( T_SERIAL_RPOR* pk_rpor );
 * call port : cSysLog  signature: sSysLog context: task
 *   ER             cSysLog_write( uint_t priority, const SYSLOG* p_syslog );
 *   ER_UINT        cSysLog_read( SYSLOG* p_syslog );
 *   ER             cSysLog_mask( uint_t logMask, uint_t lowMask );
 *   ER             cSysLog_refer( T_SYSLOG_RLOG* pk_rlog );
 * call port : cLinetracerControl  signature: sLinetracerControl context: task
 *   void           cLinetracerControl_setLightThreshold( uint8_t color, uint16_t light );
 *   void           cLinetracerControl_getLightThreshold( uint8_t color, uint16_t* light );
 *   void           cLinetracerControl_setEdge( int8_t edge );
 *   void           cLinetracerControl_getEdge( int8_t* edge );
 * call port : cBalancerControl  signature: sBalancerControl context: task
 *   void           cBalancerControl_setSpeed( int16_t speed );
 *   void           cBalancerControl_getSpeed( int16_t* speed );
 *   void           cBalancerControl_setTurn( int16_t turn );
 *   void           cBalancerControl_getTurn( int16_t* turn );
 *   void           cBalancerControl_calibrate( );
 * call port : cSemaphore  signature: sSemaphore context: task
 *   ER             cSemaphore_signal( );
 *   ER             cSemaphore_wait( );
 *   ER             cSemaphore_waitPolling( );
 *   ER             cSemaphore_waitTimeout( TMO timeout );
 *   ER             cSemaphore_initialize( );
 *   ER             cSemaphore_refer( T_RSEM* pk_semaphoreStatus );
 *
 * #[</PREAMBLE>]# */

/* ץȥѿ򤳤˽񤭤ޤ #_PAC_# */
#include "tGetCommandTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tGetCommandTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
    char buffer[2];
    char command = 0;
	SYSTIM current;

    /* ꥢݡȤ򥪡ץ */
    cSerialPort_open();

    while(1){
        command = '\0';

        /* ꥢݡȤ1ʸ */
        syslog(LOG_INFO, "wait serial send time(%d)", current);
        cSerialPort_read(buffer, 1);
        syslog(LOG_INFO, "get serial data. buffer(%c) time(%d)", buffer[0], current);
        
        /* ꥢǡβ */
        if(buffer[0] == '-'){
            VAR_sign = -1 * VAR_sign;
        }else if(buffer[0] >= '0' && buffer[0] <= '9'){
            VAR_parameter = VAR_parameter * 10 + (buffer[0] - '0');
        }else if(buffer[0] >= 'A'){
            if(buffer[0] <= 'Z'){
                buffer[0] += 0x20;
            }
            if(buffer[0] >= 'a' && buffer[0] <= 'z'){
                command = buffer[0];
                getTime(&current);
            }
        }

        /* ƥؤΥޥɤ */
        switch(command){
            case 'g':
                /*  */
                if(cSemaphore_signal() == E_OK){
                    if((VAR_parameter*VAR_sign & 1) != 0){
                        cLinetracerControl_setEdge(-1);
                    } else {
                        cLinetracerControl_setEdge(1);
                    }
                    cBalancerControl_calibrate();
                    syslog(LOG_NOTICE, "start running. edge(%d) time(%d)", VAR_parameter*VAR_sign, current);
                }
                break;

            case 's':
                /* ȥå */
                cBalancerControl_setSpeed(0);
                syslog(LOG_NOTICE, "stop running. time(%d)", current);
                break;

            case 'b':
                /* 󥵤ͥå */
                cLinetracerControl_setLightThreshold(0, VAR_parameter*VAR_sign);
                syslog(LOG_NOTICE, "set black light. light(%d) time(%d)", VAR_parameter*VAR_sign, current);
                break;
            case 'w':
                /* 󥵤ͥå */
                cLinetracerControl_setLightThreshold(1, VAR_parameter*VAR_sign);
                syslog(LOG_NOTICE, "set white light. light(%d) time(%d)", VAR_parameter*VAR_sign, current);
                break;
            case 'l':
                /* 󥵤ͥå */
                cLinetracerControl_setLightThreshold(2, VAR_parameter*VAR_sign);
                syslog(LOG_NOTICE, "set light threshold. light(%d) time(%d)", VAR_parameter*VAR_sign, current);
                break;

            case 'i':
                /* ޥ򥻥å */
                if(VAR_parameter*VAR_sign >= 3 && VAR_parameter*VAR_sign <= 7){
                    cSysLog_mask(LOG_UPTO(VAR_parameter*VAR_sign), LOG_UPTO(LOG_EMERG));
                    syslog(LOG_NOTICE, "set log mask. log_mask(%d) time(%d)", VAR_parameter*VAR_sign, current);
                }
                break;

            case 'f':
                /* ԡɥå */
                if(VAR_parameter != 0){
                    cBalancerControl_setSpeed((int16_t)VAR_parameter * (int16_t)VAR_sign);
                    syslog(LOG_NOTICE, "set speed. speed(%d) time(%d)", VAR_parameter*VAR_sign, current);
                }
                break;
            case 't':
                /* ѥå */
                if(VAR_parameter >= 0){
                    cTailController_setAngle(VAR_parameter);
                    syslog(LOG_NOTICE, "set tail angle. angle(%d) time(%d)", VAR_parameter*VAR_sign, current);
                }
                break;

            default:
                /* commandꤵʤäϲ⤷ʤ */
                break;
        }

        /* ХåեΥꥢ */
        if(command){
            VAR_parameter = 0;
            VAR_sign = 1;
            syslog(LOG_NOTICE, "command(%d) time(%d): parameter reset.", VAR_parameter*VAR_sign, current);
        }
    }
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
