/*
	target_entry_point.S

	ץFLASHRAM˥ɤ

*/

/*--------------------------------------------------------------------*/

	.global Target_Entry_Point

	.text
	.code 32
	.align 	0

#define RAM_START 0x00020000

/*
 * r0: ץFLASHǤΥɥ쥹
 * r1: ե륵
 */
Target_Entry_Point:

	/* globally disable interrupts */
	STMDB	sp!, {r0}		/* Push r0						*/
	MRS	r0, CPSR			/* Get CPSR						*/
	ORR	r0, r0, #0xC0		/* Disable IRQ, FIQ				*/
	MSR	CPSR, r0			/* Write back modified value	*/
	LDMIA	sp!, {r0}		/* Pop r0						*/

	add	r2, r0, r1      /* r2 : ץνü */
	mov	r1, #RAM_START	/* r1 : RAMƬ */
 	add	r0, r0, #16	    /* إåФ (12 + 4 byte) */

CopyToRAM:
	cmp r0, r2             /* λȽ */
	beq JumpToResetVector
	ldr r3, [r0], #4       /* FLASH */
	str r3, [r1], #4       /* RAM     */
	b CopyToRAM
	
JumpToResetVector:
 	mov	PC, #RAM_START /* ꥻåȥ٥RAMƬ֤Ƥ */

