#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2012 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: OpaqueRPCPlugin.rb 1727 2012-05-06 13:08:30Z okuma-top $
#++

# mikan through plugin: namespace θƤʤ
# Ѥ硢ʲΤ褦 toppers_jsp.cdl sChannel.cdl ꤹɬפ
# tecsgen toppers_jsp.cdl sChannel.cdl your_description.cdl

# ʲ»
#  ƤӸƤΥǥchar, short, int_t, long_t, intptr_t ΥƱ
#  ͭ桢̵ǥƱ

require_tecsgen_lib "GenOpaqueMarshaler.rb"
require_tecsgen_lib "GenParamCopy.rb"

class OpaqueRPCPlugin < ThroughPlugin

  include GenOpaqueMarshaler
  include GenParamCopy

  # OpaqueRPCPlugin ѤΥץ
  OpaqueRPCPluginArgProc = RPCPluginArgProc.dup  # ʣäƸѹʤ褦ˤ
  OpaqueRPCPluginArgProc[ "noClientSemaphore"  ] = Proc.new { |obj,rhs| obj.set_noClientSemaphore rhs }

  #=== RPCPlugin  initialize
  #   ThroughPlugin (plugin.rb) 򻲾
  def initialize( cell_name, plugin_arg, next_cell, next_cell_port_name, signature, celltype, caller_cell )
    super
    @b_noClientSemaphore = false
    initialize_opaque_marshaler

    @plugin_arg_check_proc_tab = OpaqueRPCPluginArgProc
    parse_plugin_arg

    print "OpaqueRPCPlugin: #{@clientChannelCell}\n"

    @rpc_server_channel_celltype_name = "tOpaqueRPCPlugin_#{@TDRCelltype}_#{@serverChannelCelltype}_#{@signature.get_name}"
    @rpc_server_channel_celltype_file_name = "#{$gen}/#{@rpc_server_channel_celltype_name}.cdl"
    @rpc_client_channel_celltype_name = "tOpaqueRPCPlugin_#{@TDRCelltype}_#{@clientChannelCelltype}_#{@signature.get_name}"
    @rpc_client_channel_celltype_file_name = "#{$gen}/#{@rpc_client_channel_celltype_name}.cdl"

    # mikan PPAllocator ɬ׾Դ
    if @signature.need_PPAllocator? then
      if @PPAllocatorSize == nil then
        cdl_error( "PPAllocatorSize must be speicified for oneway [in] array" )
      end
    end
  end

  def gen_plugin_decl_code( file )

    gen_marshaler_celltype

    # ͥ composite 륿פ
    #  줿 CDL եϡtecsgen ľ import ΤǤϤʤ
    #  륳ɤ CDL  import 

    f = CFile.open( @rpc_client_channel_celltype_file_name, "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT
import( <sChannel.cdl> );
import( <TDR.cdl> );
import( "#{@marshaler_celltype_file_name}" );

/* RPC Client side composite celltype */
composite #{@rpc_client_channel_celltype_name} {
  /* marshaler entry port */
  entry #{@signature.get_name} eThroughEntry;
  call  sChannel cChannel;
  [optional]
    call sRPCErrorHandler cErrorHandler;
  [optional]
    call sSemaphore cLockChannel;

  cell #{@TDRCelltype} TDR {
    cChannel => composite.cChannel;
  };
  cell #{@marshaler_celltype_name} Marshaler{
    cTDR = TDR.eTDR;
    cErrorHandler => composite.cErrorHandler;
    cLockChannel  => composite.cLockChannel;
  };

  composite.eThroughEntry => Marshaler.eClientEntry;
};
EOT
    f.close

    if @PPAllocatorSize then
      alloc_cell = "  cell tPPAllocator PPAllocator {\n    heapSize = #{@PPAllocatorSize};\n  };\n"
      alloc_call_port_join = "    cPPAllocator = PPAllocator.ePPAllocator;\n"
    else
      alloc_cell = ""
      alloc_call_port_join = ""
    end

    f = CFile.open( @rpc_server_channel_celltype_file_name, "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT
import( <sChannel.cdl> );
import( <TDR.cdl> );
import( "#{@marshaler_celltype_file_name}" );

/* RPC Server side composite celltype */
composite #{@rpc_server_channel_celltype_name} {
  /* Interface */
  call  #{@signature.get_name} #{@call_port_name};
  call  sChannel   cChannel;
  [optional]
    call sRPCErrorHandler cErrorHandler;
  entry sTaskBody  doService;

  /* Implementation */
  cell #{@TDRCelltype} TDR {
    cChannel => composite.cChannel;
  };
#{alloc_cell}  cell #{@unmarshaler_celltype_name} Unmarshaler{
    cTDR        = TDR.eTDR;
    cErrorHandler => composite.cErrorHandler;
    cServerCall => composite.#{@call_port_name};
#{alloc_call_port_join}  };
  composite.doService => Unmarshaler.doService;
};
EOT

    f.close
  end

  #===  through cell ɤ
  #
  #
  def gen_through_cell_code( file )

    gen_plugin_decl_code( file )

    # õ
    # path =["::",@next_cell.get_name]  # mikan namespace
    # cell = Namespace.find( path )
    cell = Namespace.find( @next_cell.get_namespace_path )

    file.print <<EOT
import( "#{@rpc_client_channel_celltype_file_name}" );
import( "#{@rpc_server_channel_celltype_file_name}" );

EOT

    ##### 饤¦Υ #####
    nest = @start_region.gen_region_str_pre file
    nest_str = "  " * nest

    # ޥե
    if @b_noClientSemaphore == false then
      file.print <<EOT

#{nest_str}  //  Semaphore for Multi-task use ("specify noClientSemaphore" option to delete this)
#{nest_str}  cell #{@semaphoreCelltype} #{@serverChannelCell}_Semaphore{
#{nest_str}    #{@semaphoreInitializer}
#{nest_str}  };
EOT
    end

    # 饤¦ͥ (TINET, Socket ʤ)
    file.print <<EOT
#{nest_str}  //  Client Side Channel
#{nest_str}  cell #{@clientChannelCelltype} #{@clientChannelCell}{
#{nest_str}    #{@clientChannelInitializer}
#{nest_str}  };

#{nest_str}  //  Marshaler
EOT

    # ޥեηʸ
    if @b_noClientSemaphore == false then
      semaphore = "#{nest_str}    cLockChannel = #{@serverChannelCell}_Semaphore.eSemaphore;\n"
    else
      semaphore = ""
    end

    ### 饤¦ͥ (ޡ+TDR) ###
    # λ꤬뤫
    if cell.get_allocator_list.length > 0 then

      file.print nest_str
      file.print "[allocator("

      delim = ""
      cell.get_allocator_list.each do |type, eport, subsc, func, buf, alloc|

        alloc_str = alloc.to_s
        subst = @substituteAllocator[alloc_str.to_sym]
        if subst then
          alloc_str = subst[2]+"."+subst[3]
        end

        file.print delim
        delim = ",\n"        # ǽԤˤϽФʤ

        if subsc then        # ź
          subsc_str = '[#{subsc}]'
        else
          subsc_str = ""
        end

        eport = "eThroughEntry" #RPCμ̾ѹ
        file.print nest_str
        file.print  "#{eport}#{subsc_str}.#{func}.#{buf} = #{alloc_str}"
      end

      file.puts ")]"
    end

    if @clientErrorHandler then
      clientErrorHandler_str = "#{nest_str}    cErrorHandler = #{@clientErrorHandler};\n"
    else
      clientErrorHandler_str = ""
    end

    file.print <<EOT
#{nest_str}  cell #{@rpc_client_channel_celltype_name} #{@cell_name} {
#{nest_str}    cChannel = #{@clientChannelCell}.eC0;
#{clientErrorHandler_str}#{semaphore}#{nest_str}  };

EOT
    ### END: 饤¦ͥ (ޡ+TDR) ###

    @start_region.gen_region_str_post file
    file.print "\n\n"

    ##### С¦Υ #####
    nest = @end_region.gen_region_str_pre file
    nest_str = "  " * nest

    if @serverErrorHandler then
      serverErrorHandler_str = "#{nest_str}    cErrorHandler = #{@serverErrorHandler};\n"
    else
      serverErrorHandler_str = ""
    end

    if @b_genOpener then
      opener = "#{nest_str}    cOpener       = #{@serverChannelCell}.eOpener;\n"
    else
      opener = ""
    end

    # С¦ͥ (TINET, Socket ʤ)
    file.print <<EOT

#{nest_str}  //  Server Side Channel
#{nest_str}  cell #{@serverChannelCelltype} #{@serverChannelCell}{
#{nest_str}    #{@serverChannelInitializer}
#{nest_str}  };
EOT

    # С¦ͥ (ޡ+TDR)
    file.print <<EOT

#{nest_str}  //  Unmarshaler
#{nest_str}  cell #{@rpc_server_channel_celltype_name} #{@serverChannelCell}_Unmarshaler {
#{nest_str}    cChannel = #{@serverChannelCell}.eC1;
#{nest_str}    #{@call_port_name} = #{@next_cell.get_namespace_path.get_path_str}.#{@next_cell_port_name};
#{serverErrorHandler_str}#{nest_str}  };
EOT

    # С¦ᥤ
    file.print <<EOT

#{nest_str}  //  Unmarshaler Task Main
#{nest_str}  cell #{@taskMainCelltype} #{@serverChannelCell}_TaskMain {
#{nest_str}    cMain         = #{@serverChannelCell}_Unmarshaler.doService;
#{opener}#{nest_str}  };
EOT

    # С¦
    file.print <<EOT

#{nest_str}  //  Unmarshaler Task
#{nest_str}  cell #{@taskCelltype} #{@serverChannelCell}_Task {
#{nest_str}    cBody         = #{@serverChannelCell}_TaskMain.eMain;
#{nest_str}    priority      = #{@taskPriority};
#{nest_str}    stackSize     = #{@stackSize};
#{nest_str}    taskAttribute = C_EXP( "TA_ACT" );  /* mikan : marshaler task starts at beginning */
#{nest_str}  };
EOT
    @end_region.gen_region_str_post file
  end

  #=== ץ饰 noClientSemaphore Υå
  def set_noClientSemaphore rhs
    rhs = rhs.to_sym
    if rhs == :true then
      @b_noClientSemaphore = true
    elsif rhs == :false then
      @b_noClientSemaphore = false
    else
      cdl_error( "RPCPlugin: specify true or false for noClientSemaphore" )
    end
  end
end


